<?php
/**
 * 
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 * 
 */
require_once(dirname(__FILE__) . '/../module/Net/UserAgent/Mobile.php');

/**
 * üξ򰷤饹
 *
 * оݤȤü $_SERVER ꤹ롣
 * ٤ƤΥ᥽åɤϥ饹᥽åɡ
 */
class GC_MobileUserAgent {
	/**
	 * üΥꥢɽʸ롣
	 *
	 * ʸ docomo, ezweb, softbank Τ줫
	 *
	 * @return string|false üΥꥢɽʸ֤
	 *                      üǤϤʤ false ֤
	 */
	function getCarrier() {
		$objAgent =& Net_UserAgent_Mobile::singleton();
		if (Net_UserAgent_Mobile::isError($objAgent)) {
			return false;
		}

		switch ($objAgent->getCarrierShortName()) {
		case 'I':
			return 'docomo';
		case 'E':
			return 'ezweb';
		case 'V':
			return 'softbank';
		default:
			return false;
		}
	}

	/**
	 * ꥵȤѲǽʷü/ѼԤID롣
	 *
	 * ƥꥢǻѤIDμ:
	 * + docomo   ... UTN
	 * + ezweb    ... EZֹ
	 * + softbank ... üꥢֹ
	 *
	 * @return string|false ID֤Ǥʤä false ֤
	 */
	function getId() {
		$objAgent =& Net_UserAgent_Mobile::singleton();
		if (Net_UserAgent_Mobile::isError($objAgent)) {
			return false;
		} elseif ($objAgent->isDoCoMo() || $objAgent->isVodafone()) {
			$id = $objAgent->getSerialNumber();
		} elseif ($objAgent->isEZweb()) {
			$id = @$_SERVER['HTTP_X_UP_SUBNO'];
		}
		return isset($id) ? $id : false;
	}

	/**
	 * üεɽʸ롣
	 * üǤϤʤϥ桼Ȥ̾롣(: "Mozilla")
	 *
	 * @return string üΥǥɽʸ֤
	 */
	function getModel() {
		$objAgent =& Net_UserAgent_Mobile::singleton();
		if (Net_UserAgent_Mobile::isError($objAgent)) {
			return 'Unknown';
		} elseif ($objAgent->isNonMobile()) {
			return $objAgent->getName();
		} else {
			return $objAgent->getModel();
		}
	}

	/**
	 * EC-CUBE ݡȤӥꥢɤȽ̤롣
	 *
	 * @return boolean ݡȤƤ trueʳξ false ֤
	 */
	function isMobile() {
		$objAgent =& Net_UserAgent_Mobile::singleton();
		if (Net_UserAgent_Mobile::isError($objAgent)) {
            gfPrintLog("[isMobile:Error] " . $objAgent->getUserAgent());
            mb_send_mail(DB_ERROR_MAIL_TO, DB_ERROR_MAIL_SUBJECT, "[isMobile:Error] " . $objAgent->getUserAgent());            
			return false;
		} else {
            if($objAgent->isDoCoMo()) {
                gfPrintLog("[isMobile:Docomo] " . $objAgent->getUserAgent());            
                return true;
            } elseif ($objAgent->isEZweb()) {
                gfPrintLog("[isMobile:EZweb] " . $objAgent->getUserAgent());            
                return true;
            } elseif ($objAgent->isVodafone()) {
                gfPrintLog("[isMobile:Vodafone] " . $objAgent->getUserAgent());            
                return true;
            } else {
                gfPrintLog("[isMobile:UNKNOWN] " . $objAgent->getUserAgent());
                return false;
            }
		}
	}

	/**
	 * EC-CUBE ݡȤӥꥢɤȽ̤롣
	 *
	 * @return boolean üǤϤʤ trueʳξ false ֤
	 */
	function isNonMobile() {
		return !GC_MobileUserAgent::isMobile();
	}

	/**
	 * EC-CUBE ݡȤüɤȽ̤롣
	 *
	 * @return boolean ݡȤƤ trueʳξ false ֤
	 */
	function isSupported() {
		$objAgent =& Net_UserAgent_Mobile::singleton();

		// üǧ줿User-Agent η̤Τξ
		if (Net_UserAgent_Mobile::isError($objAgent)) {
			gfPrintLog($objAgent->toString());
			return false;
		}
        
		if ($objAgent->isDoCoMo()) {
			$arrUnsupportedSeries = array('501i', '502i', '209i', '210i');
			$arrUnsupportedModels = array('SH821i', 'N821i', 'P821i ', 'P651ps', 'R691i', 'F671i', 'SH251i', 'SH251iS');
			return !in_array($objAgent->getSeries(), $arrUnsupportedSeries) && !in_array($objAgent->getModel(), $arrUnsupportedModels);
		} elseif ($objAgent->isEZweb()) {
			return $objAgent->isWAP2();
		} elseif ($objAgent->isVodafone()) {
			return $objAgent->isPacketCompliant();
		} else {
			// üǤϤʤϥݡȤƤ뤳Ȥˤ롣
			return true;
		}
	}
}
?>
